#ifndef _UAMM_H_
#define _UAMM_H_

#include <linux/bitops.h>
#include <linux/io.h>
#include <linux/mutex.h>
#include <linux/platform_device.h>
#include <linux/types.h>
#include <linux/wait.h>

#include "local_cbuff.h"

/******************************************************************************
 * Макроопределения специфичных для устройства
 *****************************************************************************/
/** максимальны размер слова даных (4х байтных слов) */
#define SPI_MAX_PAYLOAD_WORD32              (4)
/** размер кругового rx/tx буфера */
#define DEV_CBUFF_DEPTH                     (128)
/** длительность ожидания прерывания от устройства (rx/tx) */
#define DEV_WAIT_TIME                       (2000 * HZ)
/** вычисление максимальной частоты sclk из системной частоты */
#define _SPI3ST_GET_MAX_CLK_RATE(base_rate) \
    ({                                      \
        base_rate / 4                       \
    })

/******************************************************************************
 * Макроопределения общих ресурсов
 *****************************************************************************/
/** имя модуля */
#define THIS_MODULE_NAME                    "spi3st"
/**
 * минимальное отношение тактовой частоты модуля spi к частоте sclk
 * 2 - аппаратно-зависимый параметр
 */
#define MIN_SPI_CLK2SCLK_RATE               (2)

/******************************************************************************
 * Вспомогательные макроопределения
 *****************************************************************************/
/** флаг указывающий на необходимость вывода отладочной информации (если != 0)*/
#define ON_MSG_INFO 1

#define MSG_INFO(str,arg...)                                        \
    ({                                                              \
        if (ON_MSG_INFO)                                            \
            printk(KERN_INFO THIS_MODULE_NAME ": " str,##arg);      \
    })

#define MSG_WARN(str,arg...)                                        \
    ({                                                              \
        if (ON_MSG_INFO)                                            \
            printk(KERN_WARNING THIS_MODULE_NAME ": " str,##arg);   \
    })

#define MSG_ERR(str,arg...)                                         \
    ({                                                              \
        printk(KERN_ERR THIS_MODULE_NAME ": [%s,%d]"                \
            str,                                                    \
            __func__,                                               \
            __LINE__,                                               \
            ##arg                                                   \
            );                                                      \
    })

/******************************************************************************
 * Определения типов специфичных для драйвера
 *****************************************************************************/

/**
 * Структура контрольного регистра
 */
union spi3st_ctrl
{
    struct
    {
#define _SPI3ST_TRANS_WIDTH (7)
        /** размер одой транзакции в битах */
        u32                 trans_len   : _SPI3ST_TRANS_WIDTH;
        /**
         * количество тактов в двунаправленной посылке (следующие первыми)
         * которые предназначены для передачи, оставшиеся такты будут 
         * использоаваться для приема
         */
        u32                 o_len       : _SPI3ST_TRANS_WIDTH;
        /** флаг запуска транзакцию */
        u32                 run         : 1;
        /**
         * флаг включающий кольцевой режим, т.е. соеддиняющий mosi и miso
         * Внимание!
         *     Использовать только с выключенным режимом 3st.
         */
        u32                 loopback    : 1;
        /** поле устанавливающее начальное состояние линии сигнала sclk */
        u32                 cpol        : 1;
        /**
         * поле устанавливающее режим захвата входных данных по отрицательному 
         * фронту тактирующего сигнала
         */
        u32                 cpha_rx     : 1;
        /**
         * поле устанавливающее режим формирования посылки по отрицательному 
         * фронту тактирующего сигнала
         */
        u32                 cpha_tx     : 1;
        /**
         * поле указывающее что транзакции должны начинаться с младшего, 0-го
         * бита (data[0])
         */
        u32                 lsb_mode    : 1;
        /** поле разрешающее прерывания */
        u32                 ie_en       : 1;
        /** активация режима автоматического управления линией SS */
        u32                 ass         : 1;
        /** активация режима 2х проводного режима */
        u32                 en_3st      : 1;
        /** установить активный уровень сигнала cs как высокий */
        u32                 cs_is_pos   : 1;
        /** маска выбора подчиненного устройства */
#define _SPI3ST_SS_LEN_BITS (8)
        u32                 ss          : _SPI3ST_SS_LEN_BITS;
    }                   reg;
    u32                 mem;
};

/**
 * Структура контрольно-статусного регистра устройства uart-amm
 */
struct spi3st_csr
{
    /** регистр управления устройством */
    union spi3st_ctrl   cr;
    /** делитель частоты для формирования полупериода */
    u32                 baud_div;
};

/**
 * Структура устройства mbox
 */
struct spi3st_dev
{
    /** указатель на отображение io памяти CSR устройства */
    void __iomem*               csr_io;
    /** структура CSR устройства */
    struct spi3st_csr           dev_csr;
    /** номер прерывния устройства */
    int                         irq;
    /** указатель на принимаемые данные */
    void*                       rx_buf;
    /** указатель на передаваемые данные */
    void*                       tx_buf;
    /** длина трансфера в байтах */
    u32                         transfer_len;
    /** величина системной тактовой частоты устройства (в герцах) */
    u32                         sys_clk_rate;
    /** количество байт в слове участвующем в транзакции */
    u32                         bytes_per_word;
    /**  */
};

/**
 * @brief Смещения полей csr (в байтах)
 */
enum spi3st_csr_spans
{
    /** Смещение регистра отправляемых данных */
    SPI3ST_TX_REG       = 0x00,
    /** Смещение регистра считываемых данных */
    SPI3ST_RX_REG       = 0x10,
    /** Смещение контрольного регистра */
    SPI3ST_CR_REG       = 0x20,
    /** Смещение регистра делителя тактовой частоты */
    SPI3ST_BAUD_REG     = 0x24
};


/******************************************************************************
 * Inline функции
 *****************************************************************************/
/******************************************************************************
 * Функция чтения 4-х байтного регистра контрля csr
 *
 * @dev     указатель на структуру устройства
 *
 * Return   считанное 4-байтное слово
 *****************************************************************************/
static inline u32 _cr_rd32(
    struct spi3st_dev*      dev
    )
{
    return ioread32(dev->csr_io + SPI3ST_CR_REG);
}

/******************************************************************************
 * Функция записи 4-х байтного регистра контрля csr
 *
 * @dev     указатель на структуру устройства
 *****************************************************************************/
static inline void _cr_wr32(
    struct spi3st_dev*      dev
    )
{
    iowrite32(
        dev->dev_csr.cr.mem,
          dev->csr_io
        + SPI3ST_CR_REG
        );
    return;
}

/******************************************************************************
 * Функция записи 4-х байтного регистра делителя частоты csr
 *
 * @dev     указатель на структуру устройства
 *****************************************************************************/
static inline void _bdr_wr32(
    struct spi3st_dev*      dev
    )
{
    iowrite32(
        dev->dev_csr.baud_div,
          dev->csr_io
        + SPI3ST_BAUD_REG
        );
    return;
}

/******************************************************************************
 * Функция чтения 4-х байтного регистра данных csr
 * 
 * @dev     указатель на структуру устройства
 *****************************************************************************/
static inline void _rx_rd32(
    struct spi3st_dev*      dev,
    u32*                    rx_buff
    )
{
    u32 idx;
    u32* local_tx_pt;
    /* 
     * посчитаем сколько нужно 4х байтных слов для передачи слова 
     * Если количество превышает допустимый размер - прочитаем максимально
     * допустимое количество слов
     */
    u32 len_in_32w = DIV_ROUND_UP(dev->bytes_per_word, sizeof(u32));
    if(len_in_32w > SPI_MAX_PAYLOAD_WORD32)
    {
        len_in_32w = SPI_MAX_PAYLOAD_WORD32;
    }

    local_tx_pt = (u32*)dev->tx_buf;
    for(idx = 0; idx < len_in_32w; idx++)
    {
        rx_buff[idx] = ioread32(
              dev->csr_io
            + SPI3ST_RX_REG
            + idx * sizeof(u32)
            );
    }
    return;
}

/******************************************************************************
 * Функция записи регистра данных ip ядра
 *
 * @dev     указатель на структуру устройства;
 * @dat     указатель на буфер данных;
 *****************************************************************************/
static inline int _tx_wr32(
    struct spi3st_dev*      dev
    )
{
    u32  idx;
    u32* local_tx_pt;
    /* 
     * посчитаем сколько нужно 4х байтных слов для передачи слова 
     */
    u32 len_in_32w = DIV_ROUND_UP(dev->bytes_per_word, sizeof(u32));
    if(len_in_32w > SPI_MAX_PAYLOAD_WORD32)
    {
        return(-EINVAL);
    }

    local_tx_pt = (u32*)dev->tx_buf;
    for(idx = 0; idx < len_in_32w; idx++)
    {
        iowrite32(
            *local_tx_pt++,
              dev->csr_io
            + SPI3ST_TX_REG
            + idx * sizeof(u32)
            );

    }
    return(0);
}

/******************************************************************************
 * Функция обнуления регистра данных ip ядра
 *
 * @dev     указатель на структуру устройства;
 *****************************************************************************/
static inline void _clean_tx_reg(
    struct spi3st_dev*      dev
    )
{
    u32 idx;
    for(idx = 0; idx < SPI_MAX_PAYLOAD_WORD32; idx++)
    {
        iowrite32(
            0x00,
              dev->csr_io
            + SPI3ST_TX_REG
            + idx * sizeof(u32)
            );
    }
    return;
}

/******************************************************************************
 * Прототипы
 *****************************************************************************/
static int spi3st_probe(
    struct platform_device*     pdev
    );
static int spi3st_remove(
    struct platform_device*     pdev
    );

#endif /* _UAMM_H_ */
